#ifndef _matsubtract_n_
#define _matsubtract_n_

#include "./utils/vector.h"
#include "./utils/matrix.h"
#include "./core/omp_config.h"

namespace numerics{
	
	template <typename T>
	void inplace_matsubtract_colvec(utils::Matrix<T>& A, const utils::Vector<T>& x) {
	    
	    const uint64_t rows = A.rows();
	    const uint64_t cols = A.cols();

	    if (rows != x.size()) {
	        throw std::runtime_error("inplace_matsubtract_colvec: dimension mismatch");
	    }

	    for (uint64_t i = 0; i < cols; ++i) {
	        for (uint64_t j = 0; j < rows; ++j) {
	            A(j, i) -=  x[j];
	        }
	    }
	}

	template <typename T>
	void inplace_matsubtract_rowvec(utils::Matrix<T>& A, const utils::Vector<T>& x) {
	    
	    const uint64_t rows = A.rows();
	    const uint64_t cols = A.cols();

	    if (cols != x.size()) {
	        throw std::runtime_error("inplace_matsubtract_rowvec: dimension mismatch");
	    }

	    for (uint64_t i = 0; i < cols; ++i) {
	        for (uint64_t j = 0; j < rows; ++j) {
	            A(j, i) -=  x[i];
	        }
	    }
	}

	template <typename T>
	utils::Matrix<T> matsubtract_colvec(const utils::Matrix<T>& A, const utils::Vector<T>& x) {
	    
	    //const uint64_t rows = A.rows();
	    //const uint64_t cols = A.cols();

	    utils::Matrix<T> B = A;

	    inplace_matsubtract_colvec(B, x);

	    return B;
	}

	template <typename T>
	utils::Matrix<T> matsubtract_rowvec(const utils::Matrix<T>& A, const utils::Vector<T>& x) {
	    
	    //const uint64_t rows = A.rows();
	    //const uint64_t cols = A.cols();

	    utils::Matrix<T> B = A;

	    inplace_matsubtract_rowvec(B, x);

	    return B;
	}

	template <typename T>
	utils::Matrix<T> matsubtract(const utils::Matrix<T>& A, const utils::Vector<T>& x, std::string method = "auto"){

		const uint64_t rows = A.rows();
	    const uint64_t cols = A.cols();
	    const uint64_t N = x.size();

	    if (method=="auto"){
	    	
			if (rows==cols){
				throw std::runtime_error("matsubtract: too many options for dimensions");
			} else if (rows == N){
				return matsubtract_rowvec(A, x);
			} else if (cols == N){
				return matsubtract_colvec(A, x);
			}else{
				throw std::runtime_error("matsubtract: undefined fault - auto");
			}
	    }else if(method=="row"){
				return matsubtract_rowvec(A, x);
		} else if (method=="col"){
			return matsubtract_colvec(A, x);
		}else{
			throw std::runtime_error("matsubtract: undefined fault - defined method");
		}
    }




} // namespace numerics

#endif // _matsubtract_n_